# -*- coding: utf-8 -*-
import scrapy
from moviePro.items import MovieproItem

class MovieSpider(scrapy.Spider):
    name = 'movie'
    #allowed_domains = ['www.55xia.com']
    start_urls = ['https://www.55xia.com/movie']

    #解析二级页面内容
    def parseBySecondPage(self,response):
        actor=response.xpath("/html/body/div[1]/div/div/div[1]/div[1]/div[2]/table/tbody/tr[1]/td[2]/a/text()").extract_first()
        language=response.xpath("/html/body/div[1]/div/div/div[1]/div[1]/div[2]/table/tbody/tr[5]/td[2]/a/text()").extract_first()
        longtime=response.xpath("/html/body/div[1]/div/div/div[1]/div[1]/div[2]/table/tbody/tr[8]/td[2]/text()").extract_first()

        #取出request方法的meta参数传递过来的字典
        item=response.meta.get("item")
        item["actor"] = actor
        item["language"] = language
        item["longtime"] = longtime

        #所有内容都存储到了item对象，将item对象提交给管道即可
        yield item

    def parse(self, response):
        #名称，类型，导演，语言，片长
        div_list=response.xpath("//div[@class='movie-item-in']")
        for div in div_list:
            name=div.xpath("./div[@class='meta']/h1/a/text()").extract_first()
            kind = div.xpath("./div[@class='meta']/div[@class='otherinfo']/a//text()").extract_first()
            url="https:"+div.xpath("./a/@href").extract_first()

            #创建items对象
            item=MovieproItem()
            item["name"]=name
            item["kind"] = kind
            #问题：二级页面数据怎么存入item类中。可使用meta传参给回掉函数，需字典类型

            #需要对url发起请求，获取页面数据，进行指定数据解析
            yield scrapy.Request(url=url,callback=self.parseBySecondPage,meta={"item":item})


