# -*- coding: utf-8 -*-
import scrapy
from scrapy.linkextractors import LinkExtractor
from scrapy.spiders import CrawlSpider, Rule
from scrapy_redis.spiders import RedisCrawlSpider
from redisPro.items import RedisproItem
class QiubaiSpider(RedisCrawlSpider):
    name = 'qiubai'
    #allowed_domains = ['https://www.qiushibaike.com/imgrank/']
    # start_urls = ['https://www.qiushibaike.com/pic/']
    #表示start_urls在redis中存放的位置，作用类似start_urls
    redis_key="qiubaispider"

    link=LinkExtractor(allow=r'/pic/page/\d+')
    rules = (
        Rule(link, callback='parse_item', follow=True),
    )

    def parse_item(self, response):
        div_list=response.xpath("//div[@id='content-left']/div")
        for div in div_list:
            img_url="https"+div.xpath("./div[@class='thumb']/a/img/@src").extract_first()
            item=RedisproItem()
            item['img_url']=img_url

            yield item
